test_name "PE Dashboard Rake Tasks"

require File.join(File.dirname(__FILE__), '../helpers/dashboard_rake_tasks_helper')

dashboard_hosts = get_dashboard_hosts

step "Verify there's at least one dashboard host" do
  assert(dashboard_hosts.length > 0, "No dashboard hosts found!")
end

#################################
# `defaultgroup` tasks
#################################

step "test defaultgroup:ensure_default_group rake task" do
  dashboard_hosts.each do |dashboard|
    run_rake_task(dashboard, "node:add['foo.localdomain']")
    run_rake_task(dashboard, "node:add['bar.localdomain']")

    run_rake_task(dashboard, "defaultgroup:ensure_default_group")

    results = run_rake_task(dashboard, "node:listgroups['foo.localdomain']")
    assert(results.include?("default"), "expected defaultgroup:ensure_default_group task to add group 'default'!  node:listgroups returned: #{results.join("\n")}")
    assert(results.include?("mcollective"), "expected defaultgroup:ensure_default_group task to add group 'mcollective'!  node:listgroups returned: #{results.join("\n")}")

    results = run_rake_task(dashboard, "node:listgroups['bar.localdomain']")
    assert(results.include?("default"), "expected defaultgroup:ensure_default_group task to add group 'default'!  node:listgroups returned: #{results.join("\n")}")
    assert(results.include?("mcollective"), "expected defaultgroup:ensure_default_group task to add group 'mcollective'!  node:listgroups returned: #{results.join("\n")}")

    # Make sure bar.localdomain is removed from mcollective when it is added to no mcollective

    run_rake_task(dashboard, "node:addgroup[bar.localdomain,'no mcollective']")
    run_rake_task(dashboard, "defaultgroup:ensure_default_group")

    results = run_rake_task(dashboard, "node:listgroups['foo.localdomain']")
    assert(results.include?("default"), "expected defaultgroup:ensure_default_group task to add group 'default'!  node:listgroups returned: #{results.join("\n")}")
    assert(results.include?("mcollective"), "expected defaultgroup:ensure_default_group task to add group 'mcollective'!  node:listgroups returned: #{results.join("\n")}")

    results = run_rake_task(dashboard, "node:listgroups['bar.localdomain']")
    assert(results.include?("default"), "expected defaultgroup:ensure_default_group task to add group 'default'!  node:listgroups returned: #{results.join("\n")}")
    assert(!results.include?("mcollective"), "expected defaultgroup:ensure_default_group task to remove group 'mcollective'!  node:listgroups returned: #{results.join("\n")}")

    run_rake_task(dashboard, "node:del['foo.localdomain']")
    run_rake_task(dashboard, "node:del['bar.localdomain']")
  end
end

