require "#{File.dirname(__FILE__)}/../lib/spec_helper.rb"

REPORTS_TAB_NAMES = ['All', 'Failed', 'Pending', 'Changed', 'Unchanged']
SELECTED_REPORT_TAB_NAMES = ['Metrics', 'Log', 'Events']

describe 'The Dashboard' do

  before :all do
    visit_dashboard

    # wait for nodes to load
    session.should have_css("#content", :visible => true)
  end

  after :all do
    logout
  end

  it 'should have reports link' do
    session.should have_css('div#header a', :text => 'Reports')
  end

  describe 'reports' do

    before :all do
      select_reports
    end

    it 'should have tabs' do
      check_active_tabs(REPORTS_TAB_NAMES)
    end

    it 'should have clickable tabs' do
      click_active_tabs(REPORTS_TAB_NAMES)
    end

    it 'should have at least one report' do
      select_all_reports
      session.should have_css('div#main table[class="inspector main"] tbody tr')
    end

    describe 'selected report' do

      before :all do
        select_all_reports

        session.first('div#main table[class="inspector main"] tbody tr td a').click

        # wait for the selected report to appear
        session.should have_css('div#main h2 span[class*="status"]')
      end

      it 'should have tabs' do
        check_active_tabs(SELECTED_REPORT_TAB_NAMES)
      end

      it 'should have clickable tabs' do
        click_active_tabs(SELECTED_REPORT_TAB_NAMES)
      end

    end
  end

end
